

#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<math.h>
#include"subs.h"
#include"dsyevc3.h"


// rotate all images to center of mass or and body frame 
// both operations don't take into account last particle

int main(int argc, char* argv[]){
   
   char filename[30],ofilename[30];
//   strcpy(filename,"planetTidal.part");
   if (argc<4){ 
      printf(" args: filename ofilename option \n");
   }
   strcpy(filename, argv[1]);
   strcpy(ofilename, argv[2]);
   int option;
   sscanf(argv[3],"%d",&option);
   // here are the options
   //  option =0   remove center of mass, not including last particle
   //  option =1   remove center of mass, not including last particle
   //              and rotate to body frame

   int np = findnp(filename); // get the number of particles
   printf("# np=%d\n",np);
   float tmax,dt;
   int nsnaps = getnsnaps(filename,np,&dt,&tmax); // get time info
   printf("# number of snaps = %d maxtime =%f dt =%.2f\n",nsnaps,tmax,dt);

   particle *snap_pos_init; snap_pos_init =new particle[np];  // snap storage
   particle *snap_pos_t; snap_pos_t =new particle[np];  // snap storage
   
// load initial snap shot
   int i_s=0; // first snapshot
   float time = readpossnap(filename,np, i_s, snap_pos_init); 
     // read in first snap
   com_sub(snap_pos_init, np);  // subtract out the center of mass

   char startheader[180];  // for storing header stuff
   char headerinfo[180];
   char endheader[180]; 
   char startdata[180]; 
   char enddata[180]; 
   char kch[3];
   FILE *fpi, *fpo;
   fpi = fopen(filename,"r"); // open files
   fpo = fopen(ofilename,"w");
// loop here for timesteps nsnaps here instead of 2
   for(int i_snap=0; i_snap < nsnaps; i_snap ++){
   // load snap shot 
     time=readsinglet_pos(fpi,np, snap_pos_t,
        startheader, headerinfo, endheader, startdata, enddata, kch);

     com_sub(snap_pos_t, np);  // subtract out the center of masses
     if (option ==1)
        rotate_body(snap_pos_init, snap_pos_t, np); // rotate it to original position
     // write out the snap 
     time=writesinglet_pos(fpo,np, snap_pos_t,
        startheader, headerinfo, endheader, startdata, enddata, kch);

   }
   fclose(fpo);  // close files
   fclose(fpi);  


// cleanup
   delete[] snap_pos_init;
   delete[] snap_pos_t;
}


