

#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<math.h>
#include"subs.h"
#include"dsyevc3.h"


// measure the radius of the annealed planet
// in three directions
// measures only last frame
// measure radius in three directions x,y,z
// for some reason extractlast frame has an extra first line which 
// screws up all reading as format is different
// use output of annealing!

int main(int argc, char* argv[]){
   
   char filename[30];
   if (argc<2){ 
      printf(" args: filename \n");
   }
   strcpy(filename, argv[1]);

   int np = findnp(filename); // get the number of particles
   printf("# np=%d\n",np);
   float tmax,dt;
   int nsnaps = getnsnaps(filename,np,&dt,&tmax); // get time info
   printf("# number of snaps = %d maxtime =%f dt =%.2f\n",nsnaps,tmax,dt);

   particle *snap_pos; snap_pos=new particle[np];  // snap storage
   
   float time = readpossnap(filename,np, nsnaps-1,  snap_pos);
     // read in last snap

   com_sub(snap_pos, np); // subtract Center of mass of planet
   // don't worry if m2 excluded we don't care
   int ifirst = 0; 
   int ilast = np;
   double radx=0.0;
   double rady=0.0;
   double radz=0.0;
   for(int i=ifirst;i<ilast;i++){
      double x = snap_pos[i].x;
      double y = snap_pos[i].y;
      double z = snap_pos[i].z;
      double rad = sqrt(x*x + y*y + z*z);
      if ((fabs(x) > 0.5)&&(rad > radx)) radx = rad; // look for max radius
      if ((fabs(y) > 0.5)&&(rad > rady)) rady = rad;
      if ((fabs(z) > 0.5)&&(rad > radz)) radz = rad;
   }
   printf("radx,y,z = %.3f %.3f %.3f\n",radx,rady,radz);



// cleanup
   delete[] snap_pos;
}


