

#include<stdio.h>
#include<stdlib.h>
#include<string.h>

#define M2FIRST 1   // set to 1 if second body is first particle 
                    // set to 0 if second body is last particle

void readsingle(FILE *fp);   // read a single particle
int findnp(char *filename);  // get number of particles
float readsinglet(FILE *fpi,int np);  // read a single record
int getnsnaps(char* filename, int np, float *dt_ret, float *tmax_ret); 
  // get the number of snaps and some time info
struct double3 {
  double x;
  double y;
  double z;
};
struct particle {
 float x;
 float y;
 float z;
 float vx;
 float vy;
 float vz;
 float ax;
 float ay;
 float az;
 float m;
 float r;
 float pressure;
 float density;
 float energy;
};
float readsinglet_pos(FILE *fpi,int np, particle *pos); 
   // read in positions from a single snap (pass fp advanced)
float readpossnap(char* filename,int np, int ns,  particle *snap_pos);
  // read in positions from a single snap  (pass filename)
void com_sub(particle *snap_pos, int np);  // subtract center of mass
  // from particle positions and velocities
int num_nei(particle *snap_pos, int np, float d0, float rmin,
   float x0, float y0, float z0, int *nei_list);
// return a list of all particles within a particle radius of x0,y0,z0
int nei_tensor(particle *snap_pos, int n_nei, int *nei_list, double *sw);

void eigen2b2(double Axx, double Ayy, double Axy,
   double *lambda1, double *lambda2, double *theta);
double dotproduct(double3 a, double3 b);
void nei_tensor_2d(particle *snap_pos, int n_nei, int *nei_list,
             double *lambda1, double *lambda2, double *angle);

void rotate_matrix(particle *snap_pos,  float Q[3][3], int np);
void rotate_body(particle *snap_pos_init, particle *snap_pos_sec, int nparticles);
void printmatrix(const char string[], float A[3][3]);

void rotate_body(particle *snap_pos_init, particle *snap_pos_sec, int nparticles);
void printpart_nei(particle *snap,  int n_nei, int *nei_list);

float modify_singlet(FILE *fpi,FILE *fpo, int np, particle *pos);

float writesinglet_pos(FILE *fpo,int np, particle *pos,
     char* startheader, char* headerinfo, char* endheader, char* startdata,
     char* enddata, char* kch);

float readsinglet_pos(FILE *fpi,int np, particle *pos,
     char* startheader, char* headerinfo, char* endheader, char* startdata,
     char* enddata, char* kch);

double r_mean(particle *snap_pos, int n_nei, int *nei_list);

int nei1(particle *snap_pos, int np, float x0, float y0, float z0);
double distance_two(particle *snap_pos, int id1, int id2);

void maxdl(particle *snap_pos_init, particle *snap_pos_t,
       int n_nei, int *nei_list, double rmin, int ncenter, int posneg,
       double *strain, double *dthetadphi);

double maxstrainang(particle *snap_pos, int in1, int in2);

